#include "DQuest.inc"
.plugin string86
.org $8100

fight:
	ld a, (weapon)
	cp 0
	call z, add30
	sub 30
	add a, a
	ld l, a
	ld h, 0
	ld de, weaponvalues
	add hl, de
	ld e, (hl)
	inc hl
	ld d, (hl)
	ld hl, (strength)
	add hl, de
	ld (yourattack), hl
	ld a, (relic1)
	cp 27
	call z, increasestrength
	ld a, (relic2)
	cp 27
	call z, increasestrength
	ld a, (armor)
	cp 0
	call z, add37
	sub 37
	add a, a
	ld l, a
	ld h, 0
	ld de, armorvalues
	add hl, de
	ld e, (hl)
	inc hl
	ld d, (hl)
	ld hl, (defense)
	add hl, de
	ld (yourdef), hl	
	ld b, 0
	ld a, (monster1)
	cp 2
	jr c, notportal
	cp 7
	call c, portalbackg
	cp 40
	call nc, portalbackg
	cp 8
	call z, finaldungeonback
notportal:
	ld a, (sameblock)
	cp 8
	call z, forest
	cp 9
	call z, forest
	cp 61
	call z, area2
	cp 56
	call z, forest
	cp 40
	call z, mountain
	cp 39
	call z, swamp
	sub 19
	cp 5
	call c, desert
	ld a, (leftblock)
	cp 67
	call z, mountain
	ld a, (rightblock)
	cp 67
	call z, mountain
	ld a, (downblock)
	cp 68
	call z, mountain
	ld a, b
	ld (background), a
	ld a, (monster1)
	cp 1
	jp nz, otherdungeon
	ld hl, (playerpos)
	ld de, $0ef9
	sbc hl, de
	ld a, 128
	call _divHLbyA
	ld d, l
	ld e, a
	call pickmonster
	ld a, (relic1)
	cp 28
	call z, checkmask
	ld a, (relic2)
	cp 28
	call z, checkmask
backotherdungeon:
	ld a, r
	and %00000011
	add a, b
	call getmonstats
	call changemonster
	ld a, r
	and %00001100
	rrc a
	rrc a
	inc a
backfrombossbattle:
	ld (monnum), a
	ld b, a
sethploop:
	ld a, b
	dec a
	add a, a
	ld l, a
	ld h, 0
	ld de, monhp
	add hl, de
	ld de, (monhp)
	ld (hl), e
	inc hl
	ld (hl), d
	djnz sethploop
	call drawbattlescreen
	ld a, r
	and %01111110
	rrc a
	ld (randnum), a
fightloop:
	ld bc, $2a38
	ld d, 7
	ld a, $03
	call blinkselect
	cp 2
	jp z, charrun
	cp 0
	call z, charfight
	cp 1
	call z, usefightitem
backrun:
	ld a, (alldead)
	cp 1
	jr z, donewithfight
	call monsterfight
	ld a, (alldead)
	cp 1
	jr z, donewithfight
	jr fightloop
donewithfight:
	ld bc, $030c
	ld de, $0405
	call makewindow
	ld hl, 0
	ld a, (monnum)
	ld b, a
	ld de, (mongold)
dwfloop1:
	add hl, de
	djnz dwfloop1
	ex de, hl
	ld hl, (gold)
	add hl, de
	call c, setto65535
	ld (gold), hl
	ex de, hl
	ld bc, $2548
	call drawnumber
	ld hl, fstring6
	ld de, $2520
	call drawstring
	call pause
	ld bc, $030c
	ld de, $0405
	call makewindow
	ld a, (monnum)
	ld b, a
	ld hl, 0
	ld de, (monexp)
dwfloop2:
	add hl, de
	djnz dwfloop2
	ex de, hl
	ld hl, (nextlevel)
	ld a, h
	cp 255
	jr z, neveralevelup
	inc hl
	sbc hl, de
	jr c, levelup
	jr z, levelup
neveralevelup:
	ld (nextlevel), hl
	ex de, hl
	ld bc, $2548
	call drawnumber
	ld hl, fstring7
backfromlevelup:
	ld de, $2520
	call drawstring
	call pause
	ld b, 120
	jp keyloop

levelup:
	ld hl, fstring8
	ld de, $2520
	call drawstring
	call pause
	ld hl, (level)
	dec hl
	add hl, hl
	ld de, leveldata
	add hl, de
	ld e, (hl)
	inc hl
	ld d, (hl)
	ld (nextlevel), de
	ld a, r
	ld l, a
	ld h, a
	ld a, (level)
	add a, a
	add a, 2
	call _divHLbyA
	ld e, a
	ld d, 0
	inc de
	ld hl, (strength)
	add hl, de
	ld (strength), hl
	ld a, 3
	call _divHLbyA
	ld e, a
	ld d, 0
	add hl, de
	ld (defense), hl
	ld hl, (level)
	inc hl
	ld (level), hl
	push hl
	add hl, hl
	add hl, hl
	pop de
	add hl, de
	ld a, r
	and %00001111
	ld e, a
	ld d, 0
	add hl, de
	ld de, (maxhp)
	add hl, de
	ld (maxhp), hl
	ld bc, $030c
	ld de, $0405
	call makewindow
	ld hl, (nextlevel)
	ld bc, $2540
	call drawnumber
	ld hl, fstring9
	jp backfromlevelup

add37:
	add a, 7
add30:
	add a, 30
	ret
setto65535:
	ld hl, -1
	ret

charrun:
	ld a, (montype)
	cp 40
	jp nc, backrun2
	ld a, r
	and %00000001
	cp 1
	jp z, backrun2
	ld a, (monster1)
	cp 40
	jr nc, backrun2
	ret
backrun2:
	ld bc, $030c
	ld de, $0405
	call makewindow
	ld hl, fstring10
	ld de, $2520
	call drawstring
	call pause
	call drawbattlescreen
	jp backrun

checkmask:
	ld a, b
	cp 17
	ret nc
	pop hl
	ret

increasestrength:
	ld hl, (yourattack)
	push hl
	ld a, 4
	call _divHLbyA
	ex de, hl
	pop hl
	add hl, de
	ld (yourattack), hl
	ret

pickmonster:
	ld a, d
	cp 30
	jr c, notarea1
	ld a, e
	cp 19
	jr nc, notarea1
area1:
	ld b, 0
	ret
notarea1:
	ld a, d
	cp 31
	jr nc, notarea2
	ld a, e
	cp 25
	jr nc, notarea2
area2:
	ld b, 4
	ret
notarea2:
	ld a, d
	cp 39
	jr nc, notarea7
	ld a, e
	cp 95
	jr c, notarea7
area7:
	ld b, 24
	ret
notarea7:
	ld a, d
	sub 45
	cp 2
	jr nc, notarea10
	ld a, e
	sub 75
	cp 3
	jr nc, notarea10
area10:
	ld b, 36
	ret
notarea10:
	ld a, e
	cp 69
	jr c, notarea596
	ld a, d
	cp 38
	jr c, notarea5
area5:
	ld b, 16
	ret
notarea5:
	cp 33
	jr c, area6
area32:				;technically, area 32
	ld b, 32
	ret
area6:
	ld b, 20
	ret
notarea596:
	ld a, d
	cp 16
	jr c, notarea4
	ld a, e
	cp 46
	jr c, notarea4
area4:
	ld b, 12
	ret
notarea4:
	ld b, 8
	ld a, d
	cp 27
	ret c
area9:
	ld b, 32
	ret
area3:
	ld b, 8
	ret
area8:
	ld b, 28
	ret
area11:
	ld b, 40
	ret
area12:
	ld b, 43
	ret

otherdungeon:
	cp 40
	jr nc, bossbattle
	cp 2
	call z, area11	;underworld
	cp 3
	call z, portal1dungeon
	cp 4
	call z, area3	;portal2dungeon
	cp 5
	call z, area6	;portal3dungeon
	cp 6
	call z, area7	;portal4dungeon
	cp 7
	call z, area8	;hover and scorpion caves
	cp 8
	call z, area12	;final dungeon
	jp backotherdungeon	
bossbattle:
	call getmonstats
	call changemonster
	ld a, 1
	jp backfrombossbattle
portal1dungeon:
	ld b, 5
	ret

charfight:
	call selectmonster
	push af
	ld a, 14
	ld (animvar), a
	ld b, 3
	ld a, (relic1)
	cp 30
	call z, bandanaload
	ld a, (relic2)
	cp 30
	call z, bandanaload
loopattackgfx:
	push bc
	call drawtopbattlescreen
	ld bc, $0100
	call drawchar
	ld b, 25
	call keyloop
	call drawtopbattlescreen
	ld bc, $0200
	call drawchar
	ld b, 25
	call keyloop
	pop bc
	djnz loopattackgfx
	ld (animvar), a
	ld hl, (yourattack)
	ld de, backbigattack
	ld a, h
	cp 0
	jp nz, bigattack
	ld a, r
	ld h, a
	ld l, a
	ld a, (yourattack)
	call _divHLbyA
	ld e, a
	ld d, 0
backbigattack:
	ld hl, (yourattack)
	add hl, de
	ld a, (relic1)
	cp 30
	call z, bandanaattack
	ld a, (relic2)
	cp 30
	call z, bandanaattack
	ld de, (mondef)
	sbc hl, de
	call z, setto1
	call c, setto1
	ex de, hl
	pop af
	push de
	add a, a
	ld l, a
	ld h, 0
	ld bc, monhp
	add hl, bc
	push hl
	call _ldhlind
	sub 0
	sbc hl, de
	call c, deadmonster
	call z, deadmonster
	ex de, hl
	pop hl
	ld (hl), e
	inc hl
	ld (hl), d
finishtakemonloop:
	ld bc, $030c
	ld de, $0405
	call makewindow
	pop hl
	ld bc, $2540
	call drawnumber
	ld hl, fstring4
	ld de, $2520
	call drawstring
	call pause
	call drawbattlescreen
	ld b, 4
deadmonloop:
	push bc
	ld a, b
	call checkmonster
	cp 2
	jr nz, notalldead
	pop bc
	djnz deadmonloop
	ld a, 1
	ld (alldead), a
	xor a
	ret

notalldead:
	pop bc
	xor a
	ret

deadmonster:
	ld hl, 0
	ret

setto1:
	ld hl, 1
	ret

bigattack:
	push de
	ld a, 5
	call _divHLbyA
	push hl
	ld a, r
	ld l, a
	ld h, a
	pop de
	ld a, e
	call _divHLbyA
	ld l, a
	ld h, 0
	push hl
	add hl, hl
	add hl, hl
	pop de
	add hl, de
	ex de, hl
	ret


monsterfight:
	ld a, (monspell)
	ld b, a
	ld a, r
	and b
	cp 0
	ld (tempvar1), a
	ld b, 40
	call keyloop
	ld a, 14
	ld (animvar), a
	call drawtopbattlescreen
	ld bc, $0401
	call drawchar
	ld b, 80
	call keyloop
	ld (animvar), a
	ld a, (tempvar1)
	cp 0
	call nz, spellanim
	call drawtopbattlescreen
	ld hl, (monattack)
	ld de, backbigattack2
	ld a, h
	cp 0
	jr nz, bigattack
	ld a, r
	ld h, a
	ld l, a
	ld a, (monattack)
	call _divHLbyA
	ld e, a
	ld d, 0
backbigattack2:
	ld hl, (monattack)
	ld a, (tempvar1)
	cp 0
	call nz, doublehl
	add hl, de
	ld a, (relic1)
	cp 21
	call z, usefiretablet
	cp 22
	call z, usewatertablet
	cp 23
	call z, uselittablet
	cp 24
	call z, useearthtablet
	ld a, (relic2)
	cp 21
	call z, usefiretablet
	cp 22
	call z, usewatertablet
	cp 23
	call z, uselittablet
	cp 24
	call z, useearthtablet
	ld de, (yourdef)
	sbc hl, de
	call z, setto1
	call c, setto1
	ex de, hl
	push de
	ld hl, (hp)
	sub 0
	sbc hl, de
	call c, deadmonster
	call z, deadmonster
	ld (hp), hl
	ld bc, $030c
	ld de, $0405
	call makewindow
	pop hl
	ld bc, $2540
	call drawnumber
	ld hl, fstring5
	ld de, $2520
	call drawstring
	call pause
	ld hl, (hp)
	ld de, 0
	call hlde
	cp 2
	jr z, youaredead
	call drawbattlescreen
	ld a, (relic1)
	cp 29
	jp z, charfight						;powerglove
	ld a, (relic2)
	cp 29
	jp z, charfight						;powerglove
	ret

doublehl:
	add hl, hl
	ret

youaredead:
	ld a, 14
	ld (animvar), a
	call drawbattlescreen
	ld bc, $0300
	call drawchar
	ld b, 255
	call keyloop
	ld a, (monster1)
	cp 40
	jr nc, tokendontwork
	ld a, 5
	call checkitem
	cp 1
	jr z, gotatoken
tokendontwork:
	pop hl
	pop hl
	pop hl
	ret
gotatoken:
	call dropthisitem
	ld hl, 1
	ld (hp), hl
	pop hl
	ret
	
usefiretablet:
	ld a, (monspell)
	cp 1
	ret nz
usetablet:
	ld a, (tempvar1)
	cp 0
	ret z
	ld a, 4
	call _divHLbyA
	xor a
	ret

usewatertablet:
	ld a, (monspell)
	cp 2
	ret nz
	jr usetablet

uselittablet:
	ld a, (monspell)
	cp 4
	ret nz
	jr usetablet

useearthtablet:
	ld a, (tempvar1)
	cp 0
	ret nz
	ld a, 2
	call _divHLbyA
	xor a
	ret

spellanim:
	ld de, (monmask)
	ld hl, (mondata)
	push de
	push hl
	ld a, (monspell)
	dec a
	add a, a
	add a, a
	add a, a
	add a, a
	add a, a
	push af
	add a, a
	ld l, a
	ld h, 0
	ld de, spellgfx
	add hl,de
	ld (mondata), hl
	pop bc
	ld l, b
	ld h, 0
	ld de, spellmask
	add hl, de
	ld (monmask), hl
	ld hl, $011e
	call drawmonster
	ld b, 130
	call keyloop
	pop hl
	pop de
	ld (monmask), de
	ld (mondata), hl
	call drawtopbattlescreen
	ret
	
bandanaload:
	ld a, b
	add a, b
	ld b, a
	ret

bandanaattack:
	add hl, hl
	ret

selectmonster:
	ld d, 0
smonloop3:
	inc d
	ld a, d
	call checkmonster
	cp 2
	jr z, smonloop3
smonloop:
	push de
	ld a, d
	dec a
	push af
	add a, a
	pop bc
	add a, b
	ld b, a
	ld a, 10
	sub b
	ld e, a
	ld d, 4
	ld hl, selectoricon
	call GridPutSprite
smonloop2:
	ld b, 1
	call keyloop
	cp 0
	jr z, smonloop2
	push af
	call waitkey
	call drawtopbattlescreen
	pop af
	pop de
	cp 2
	call z, moveselleft
	cp 3
	call z, moveselright
	cp 6
	jr nz, smonloop
	ld a, d
	dec a
	ret

moveselleft:
	ld c, d
nextselleft:
	ld a, c
	cp 4
	ret z
	inc c
	ld a, c
	call checkmonster
	cp 2
	jr z, nextselleft
	ld d, c
	ret

moveselright:
	ld c, d
nextselright:
	ld a, c
	cp 1
	ret z
	dec c
	ld a, c
	call checkmonster
	cp 2
	jr z, nextselright
	ld d, c
	ret


usefightitem
	call useitem
	cp 0
	jr z, gobackselect
	cp 255
	jr z, gobackselect
	cp 254
	jr z, otheritem
	call drawbattlescreen
	ret
gobackselect:
	call drawbattlescreen
	pop hl
	ld hl, fightloop
	push hl
	ret
otheritem:
	ld a, (hl)
	cp 6
	jp z, usedart
	cp 7
	jp z, usearrow
	sub 10
	cp 7
	jp c, usescroll
	jr gobackselect

usearrow:
	push hl
	ld a, 8
	call checkitem
	pop hl
	cp 0
	jr z, gobackselect
usedart:
	call dropthisitem
	call drawbattlescreen
	call selectmonster
	push af
	ld a, r
	ld e, a
	ld d, 0
	ld hl, 200
	add hl, de
	ex de, hl
	jp backbigattack
	
usescroll:
	push af
	call dropthisitem
	pop af
	cp 3
	jp c, littlescroll
	cp 6
	call z, poisonscroll
	call c, level2scroll
backlittlescroll:
	push hl
	add hl, hl
	add hl, hl
	pop de
	add hl, de
	push hl
	ld hl, (mondata)
	ld de, (monmask)
	push hl
	push de
	push af
	call drawbattlescreen
	pop af
	add a, a
	add a, a
	add a, a
	add a, a
	add a, a
	push af
	add a, a
	ld l, a
	ld h, 0
	ld de, spellgfx
	add hl,de
	ld (mondata), hl
	pop bc
	ld l, b
	ld h, 0
	ld de, spellmask
	add hl, de
	ld (monmask), hl
	call drawcharbattlescreen
	ld b, 120
	call keyloop
	pop de
	pop hl
	ld (mondata), hl
	ld (monmask), de
	pop de
	push de
	ld b, 4
scrollmonloop:
	push bc
	push de
	dec b
	ld a, b
	add a, a
	ld l, a
	ld h, 0
	ld bc, monhp
	add hl, bc
	push hl
	ld c, (hl)
	inc hl
	ld b, (hl)
	push bc
	pop hl
	sub 0
	sbc hl, de
	call c, deadmonster
	call z, deadmonster
	ex de, hl
	pop hl
	ld (hl), e
	inc hl
	ld (hl), d
	pop de
	pop bc
	djnz scrollmonloop
	jp finishtakemonloop

littlescroll:
	cp 2
	call z, makeabigger
	push af
	ld a, r
	ld l, a
	ld h, 0
	ld a, (level)
	call _divHLbyA
	ld e, a
	ld d, 0
	ld hl, (level)
	add hl, de
	ld de, 10
	add hl, de
	pop af
	jp backlittlescroll

level2scroll:
	cp 5
	call z, makeabigger
	dec a
	dec a
	dec a
	push af
	ld a, r
	ld l, a
	ld h, 0
	ld a, (level)
	add a, a
	call _divHLbyA
	ld e, a
	ld d, 0
	ld hl, (level)
	push hl
	add hl, hl
	pop bc
	add hl, bc
	add hl, de
	ld de, 20
	add hl, de
	pop af
	ret

poisonscroll:
	ld a, r
	ld l, a
	ld h, 0
	ld a, (level)
	ld b, a
	add a, a
	add a, b
	call _divHLbyA
	ld e, a
	ld d, 0
	ld hl, (level)
	add hl, hl
	add hl, hl
	add hl, de
	ld de, 110
	add hl, de
	ld a, 2
	ret

makeabigger:
	inc a
	ret

checkmonster:
	push de
	dec a
	add a, a
	ld l, a
	ld h, 0
	ld de, monhp
	add hl, de
	ld e, (hl)
	inc hl
	ld d, (hl)
	ld hl, 0
	call hlde
	pop de
	ret

drawbattlescreen:
	call drawbottomwindow
drawtopbattlescreen:
	call drawbackground
drawcharbattlescreen:
	ld a, (monnum)
	ld b, a
drawmonloop:
	push bc
	ld a, b
	push af
	call checkmonster
	cp 2
	jr z, nomonster
	pop af
	dec a
	add a, a
	ld l, a
	ld h, 0
	ld de, monpos
	add hl, de
	ld e, (hl)
	inc hl
	ld d, (hl)
	ex de, hl
	call drawmonster
finishdmlloop:
	pop bc
	djnz drawmonloop
	ld a, (animvar)
	cp 14
	ret z
	ld bc, 0
	call drawchar
	ret
nomonster:
	pop af
	jr finishdmlloop

drawchar:
	ld de, (mondata)
	push de
	ld de, (monmask)
	push de
	ld l, b
	ld h, 0
	add hl, hl
	add hl, hl
	add hl, hl
	add hl, hl
	add hl, hl
	push hl
	add hl, hl
	ld de, chargfx
	add hl, de
	ld (mondata), hl
	pop hl
	ld de, charmask
	add hl, de
	ld (monmask), hl
	ld a, (monchange)
	push af
	ld a, c
	ld (monchange), a
	ld hl, $011e
	call drawmonster
	pop af
	ld (monchange), a
	pop de
	ld (monmask), de
	pop de
	ld (mondata), de
	ret

drawbottomwindow:
	ld bc, $000f
	ld de, $0507
	call makewindow
	ld bc, $0004
	ld de, $0507
	call makewindow
	ld hl, fstring1
	ld de, $2a06
	call drawstring
	ld hl, fstring2
	ld de, $3106
	call drawstring
	ld hl, fstring3
	ld de, $3806
	call drawstring
	ld hl, hpstring
	ld de, $2a29
	call drawstring
	ld hl, (hp)
	ld bc, $2a33
	call drawnumber
	ld hl, slash
	ld de, $2a47
	call drawstring
	ld hl, (maxhp)
	ld bc, $2a4b
	call drawnumber
	ld hl, lvstring
	ld de, $2a62
	call drawstring
	ld hl, (level)
	ld bc, $2a6b
	call drawnumber
	ld hl, nextstring
	ld de, $3029
	call drawstring
	ld hl, (nextlevel)
	ld bc, $303d
	call drawnumber
	ld hl, goldstring
	ld de, $3059
	call drawstring
	ld hl, (gold)
	ld bc, $306b
	call drawnumber
	ld de, $3829
	ld hl, monnames
	ld a, (montype)
	inc a
	ld b, a
monstringloop
	push bc
	ld b, 1
	ld a, 0
	cpir
	pop bc
	djnz monstringloop
	jp drawstring

changemonster:
	push hl
	ld a, (monchange)
	cp 0
	jr z, nochange
	cp 1
	call z, reversemonster
	cp 2
	call z, invertmonster
	cp 3
	call z, darkenmonster
nochange
	pop hl
	ret

drawmonster:
	push hl
	ld de, $fc00
	add hl, de
	ld de, (mondata)
	call drawthat
	pop hl
	ld bc, $ca00
	add hl, bc
	call drawthat
	ret

drawthat:
	ld bc, (monmask)
	ld (tempword1), bc
	ld b, 16
dmonloop:
	push bc
	push hl
	ld hl, (tempword1)
	ld c, (hl)
	inc hl
	ld (tempword1), hl
	pop hl
	ld a, (hl)
	and c
	ld b, a
	ld a, c
	cpl
	ld c, a
	ld a, (de)
	and c
	or b
	ld (hl), a
	inc de
	inc hl
	push hl
	ld hl, (tempword1)
	ld a, (hl)
	inc hl
	ld (tempword1), hl
	ld c, a
	pop hl
	ld a, (hl)
	and c
	ld b, a
	ld a, c
	cpl
	ld c, a
	ld a, (de)
	and c
	or b
	ld (hl), a
	inc de
	push de
	ld de, 15
	add hl, de
	pop de
	pop bc
	djnz dmonloop
	ret

reversemonster:
	ld b, 32
	ld hl, (mondata)
	ld de, 32
	add hl, de
	ld de, (mondata)
rmonsterloop:
	ld a, (de)
	ld c, a
	ld a, (hl)
	ld (hl), c
	ld (de), a
	inc hl
	inc de
	djnz rmonsterloop
	ret

invertmonster:
	ld hl, (mondata)
	ld b, 64
imonsterloop:
	ld a, (hl)
	cpl
	ld (hl), a
	inc hl
	djnz imonsterloop
	ret

darkenmonster:
	ld b, 32
	ld hl, (mondata)
	ld de, 32
	add hl, de
	ld de, (mondata)
dmonsterloop:
	ld a, (de)
	ld c, a
	ld a, (hl)
	or c
	ld (hl), a
	ld (de), a
	inc hl
	inc de
	djnz dmonsterloop
	ret

getmonstats:
	ld (montype), a
	ld l, a
	ld h, 0
	add hl, hl
	push hl
	add hl, hl
	push hl
	add hl, hl
	pop de
	add hl, de
	pop de
	add hl, de
	ld de, monstats
	add hl, de
	ld e, (hl)
	inc hl
	ld d, (hl)
	inc hl
	ld (monhp), de
	ld e, (hl)
	inc hl
	ld d, (hl)
	inc hl
	ld (mondef), de
	ld e, (hl)
	inc hl
	ld d, (hl)
	inc hl
	ld (monattack), de
	ld e, (hl)
	inc hl
	ld d, (hl)
	inc hl
	ld (monexp), de
	ld e, (hl)
	inc hl
	ld d, (hl)
	inc hl
	ld (mongold), de
	ld a, (hl)
	inc hl
	ld (monspell), a
	ld a, (hl)
	inc hl
	ld (monweakness), a
	ld a, (hl)
	ld b, a
	inc hl
	ld a, (hl)
	ld (monchange), a
	ld l, b
	ld h, 0
	add hl, hl
	add hl, hl
	add hl, hl
	add hl, hl
	add hl, hl
	push hl
	add hl, hl
	ld de, blog
	add hl, de
	ld (mondata), hl
	pop hl
	ld de, monstermasks
	add hl, de
	ld (monmask), hl
	ret


finaldungeonback:
	ld b, 6
	ld a, (sameblock)
	cp 14
	call z, notfirstfloor
	ret

notfirstfloor:
	ld b, 7
	ret

portalbackg:
	ld b, 8
	ret

forest:
	ld b, 1
	ret

mountain:
	ld b, 2
	ret

desert:
	ld b, 3
	ret

swamp:
	ld b, 5
	ret


drawbackground:
	ld a, (background)
	ld l, a
	ld h, 0
	push hl
	add hl, hl
	add hl, hl
	pop de
	add hl, de
	ld de, backdata
	add hl, de
	ld b, 5
dbackgloop:
	push hl
	push bc
	ld a, (hl)
	add a, a
	ld l, a
	ld h, 0
	add hl, hl
	add hl, hl
	add hl, hl
	ld de, Tiledata
	add hl, de
	pop de
	push de
	dec d
	ld c, d
	ld b, 16
dbackgloop2:
	push bc
	push hl
	ld d, c
	ld e, b
	dec e
	call GridPutSprite
	pop hl
	pop bc
	djnz dbackgloop2
	pop bc
	pop hl
	inc hl
	djnz dbackgloop
	ret
;background data
;0=regular
;1=forest
;2=mountain
;3=desert
;4=shoals
backdata:
	.db 0,1,0,2,64
	.db 0,1,0,8,56
	.db 0,1,40,67,67
	.db 23,23,23,2,64
	.db 61,61,61,64,3
	.db 39, 39, 39, 23, 63
	.db 15, 15, 15, 57, 57
	.db 14, 14, 14, 96, 96
	.db 28, 28, 25, 77, 97
; Monster Variables

monpos:
	.dw $013a
	.dw $00b7
	.dw $0134
	.dw $00b1

monnum:
	.db 0

monhp:
	.dw 0, 0, 0, 0

mondata:
	.dw 0

monmask:
	.dw 0

monattack:
	.dw 0

mondef:
	.dw 0

monweakness:
	.db 0

monspell:
	.db 0

monexp:
	.dw 0

mongold:
	.dw 0

mongfx:
	.db 0

monchange:
	.db 0

background:
	.db 0

montype:
	.db 0

randnum:
	.dw 0

animvar:
	.db 0

yourattack:
	.dw 0

yourdef:
	.dw 0

alldead:
	.db 0

#include "monsterdata.asm"

selectoricon:
	.db %00011000
	.db %00101100
	.db %01000110
	.db %10000011
	.db %11101111
	.db %00101100
	.db %00101100
	.db %00111100
	.db %11101111
	.db %11000111
	.db %10000011
	.db %00000001
	.db %00000001
	.db %11000111
	.db %11000111
	.db %11000111

weaponvalues:
	.dw 5, 10, 20, 50, 125, 250, 400, 600

armorvalues:
	.dw 4, 8, 23, 45, 55, 150, 375, 750
.end
